VERSION 5.00
Begin VB.Form ImageFind 
   BackColor       =   &H00C0C0C0&
   Caption         =   "Select Image"
   ClientHeight    =   4380
   ClientLeft      =   2190
   ClientTop       =   1920
   ClientWidth     =   6525
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form2"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4380
   ScaleWidth      =   6525
   Begin VB.PictureBox Panel3D1 
      BackColor       =   &H000000FF&
      Height          =   4665
      Left            =   0
      ScaleHeight     =   4605
      ScaleWidth      =   6705
      TabIndex        =   0
      Top             =   0
      Width           =   6765
      Begin VB.DirListBox Dir1 
         Height          =   3405
         Left            =   225
         TabIndex        =   3
         Top             =   720
         Width           =   2775
      End
      Begin VB.DriveListBox Drive1 
         Height          =   315
         Left            =   225
         TabIndex        =   2
         Top             =   180
         Width           =   2775
      End
      Begin VB.FileListBox File1 
         Height          =   2235
         Left            =   3240
         Pattern         =   "*.bmp;*.dib"
         TabIndex        =   1
         Top             =   1740
         Width           =   3015
      End
      Begin VB.Image Image1 
         BorderStyle     =   1  'Fixed Single
         Height          =   1455
         Left            =   3960
         Stretch         =   -1  'True
         Top             =   165
         Width           =   1575
      End
   End
End
Attribute VB_Name = "ImageFind"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub ArrangePics()

If ImageForm.Source.Width < 0.45 * Screen.Width Then
    ImageForm.Target.Left = ImageForm.Source.Left + ImageForm.Source.Width + 20 * Screen.TwipsPerPixelX
    ImageForm.Target.Top = ImageForm.Source.Top
    ImageForm.Width = 2 * ImageForm.Source.Width + 40 * Screen.TwipsPerPixelX
    ImageForm.Height = ImageForm.Source.Height + 80 * Screen.TwipsPerPixelY
Else
    ImageForm.Target.Top = ImageForm.Source.Top + ImageForm.Source.Height + 20 * Screen.TwipsPerPixelY
    ImageForm.Target.Left = ImageForm.Source.Left
    ImageForm.Height = 2 * ImageForm.Source.Height + 80 * Screen.TwipsPerPixelY
    ImageForm.Width = ImageForm.Source.Width + 80 * Screen.TwipsPerPixelX
End If

End Sub

Private Sub Dir1_Change()
File1.Path = Dir1.Path
End Sub

Private Sub Drive1_Change()

On Error Resume Next
    Dir1.Path = Drive1.Drive

End Sub

Private Sub File1_Click()

On Error Resume Next
If Right$(File1.Path, 1) = "\" Then
    p$ = File1.Path & File1.filename
Else
    p$ = File1.Path & "\" & File1.filename
End If

imagename$ = p$
Image1.Picture = LoadPicture(p$)

End Sub

Private Sub File1_DblClick()
CF_PALETTE = 9
  
Dim pix As Byte
Dim PalEntry As String * 4
Dim RGBEntry As String * 3

ImageFind.Hide

Clipboard.Clear
ImageForm.Source.Picture = LoadPicture()
ImageForm.Target.Picture = LoadPicture()
ImageForm.Source.Picture = LoadPicture(imagename$)
Clipboard.SetData ImageForm.Source.IMAGE, CF_PALETTE
ImageForm.Target.Picture = Clipboard.GetData(CF_PALETTE)
 
ImageForm.Target.Width = ImageForm.Source.Width
ImageForm.Target.Height = ImageForm.Source.Height

' Arrange images on Form
Call ArrangePics
ImageForm.Source.Picture = LoadPicture(imagename$)

ImageForm.Source.ScaleMode = 3
ImageForm.Target.ScaleMode = 3
ImageForm.Target.Cls

Open imagename$ For Binary As #1
Get #1, , h1
Get #1, , h2

XRes = h2.biWidth
YRes = h2.biHeight

If XRes > 400 Or YRes > 400 Then
    MsgBox "Image too large", 32, "VBImage Error"
    XRes = 0
    YRes = 0
    Close #1
    Exit Sub
End If

If h2.biBitCount <> 8 And h2.biBitCount <> 24 Then
    MsgBox "Not a Color Image", 32, "VBImage Error"
    Close #1
    Exit Sub
End If


PaletteSize = 2 ^ h2.biBitCount
                
PlsWaitForm.Show
DoEvents
If h2.biBitCount = 8 Then
    For i = 0 To PaletteSize - 1
        Get #1, , PalEntry
        RGBpalette(i, 0) = Asc(Mid$(PalEntry, 3, 1))
        RGBpalette(i, 1) = Asc(Mid$(PalEntry, 2, 1))
        RGBpalette(i, 2) = Asc(Mid$(PalEntry, 1, 1))
    Next
    For i = 0 To YRes - 1
    For j = 0 To XRes - 1
        Get #1, , pix
        pic(j, i, 0) = RGBpalette(pix, 0)
        pic(j, i, 1) = RGBpalette(pix, 1)
        pic(j, i, 2) = RGBpalette(pix, 2)
    Next
    If Int(XRes / 4) <> XRes / 4 Then
        For kk = 1 To 4 - XRes Mod 4
            Get #1, , pix
        Next
    End If
    Next
Else
    For i = 0 To YRes - 1
        For j = 0 To XRes - 1
            Get #1, , RGBEntry
            pic(j, i, 0) = Asc(Mid$(RGBEntry, 1, 1))
            pic(j, i, 1) = Asc(Mid$(RGBEntry, 2, 1))
            pic(j, i, 2) = Asc(Mid$(RGBEntry, 3, 1))
        Next
        If Int((XRes * 3) / 4) <> (XRes * 3) / 4 Then
            For kk = 1 To 4 - ((XRes * 3) Mod 4)
                Get #1, , pix
            Next
        End If
    Next
End If
PlsWaitForm.Hide

Close #1

End Sub


