VERSION 5.00
Begin VB.Form ImageForm 
   Caption         =   "VBImage"
   ClientHeight    =   2430
   ClientLeft      =   1380
   ClientTop       =   2055
   ClientWidth     =   5790
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   2430
   ScaleWidth      =   5790
   Begin VB.PictureBox Target 
      AutoRedraw      =   -1  'True
      Height          =   2190
      Left            =   3030
      ScaleHeight     =   2130
      ScaleWidth      =   2610
      TabIndex        =   1
      Top             =   165
      Width           =   2670
   End
   Begin VB.PictureBox Source 
      AutoSize        =   -1  'True
      Height          =   2190
      Left            =   72
      ScaleHeight     =   2130
      ScaleWidth      =   2610
      TabIndex        =   0
      Top             =   168
      Width           =   2670
   End
   Begin VB.PictureBox CommonDialog1 
      Height          =   480
      Left            =   2625
      ScaleHeight     =   420
      ScaleWidth      =   1140
      TabIndex        =   2
      Top             =   330
      Width           =   1200
   End
   Begin VB.Menu FileMenu 
      Caption         =   "File"
      Begin VB.Menu FileOpen 
         Caption         =   "Open"
      End
      Begin VB.Menu FileSaveAs 
         Caption         =   "Save As .."
      End
      Begin VB.Menu ExitProgram 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu ProcessMenu 
      Caption         =   "Process"
      Begin VB.Menu SmoothProc 
         Caption         =   "Smooth"
      End
      Begin VB.Menu SharpenProc 
         Caption         =   "Sharpen"
      End
      Begin VB.Menu EmbossProc 
         Caption         =   "Emboss"
      End
      Begin VB.Menu EngraveProc 
         Caption         =   "Engrave"
      End
      Begin VB.Menu MosaicProc 
         Caption         =   "Mosaic"
      End
      Begin VB.Menu DiffuseProc 
         Caption         =   "Diffuse"
      End
      Begin VB.Menu NeonProc 
         Caption         =   "Neon"
      End
      Begin VB.Menu InvertProc 
         Caption         =   "Invert"
      End
      Begin VB.Menu Color2MonoProc 
         Caption         =   "Color To Mono"
      End
   End
End
Attribute VB_Name = "ImageForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Dim vpic(3) As Integer


Private Sub Color2MonoProc_Click()
Dim GrVal As Integer
'  Color 2 Mono
Target.Cls
For i = 0 To YRes - 1
    For j = 0 To XRes - 1
        GrVal = 0.3 * pic(j, i, 0) + 0.59 * pic(j, i, 1) + 0.11 * pic(j, i, 2)
        Target.PSet (j, YRes - i - 1), RGB(GrVal, GrVal, GrVal)
    Next
    Target.Refresh
Next

End Sub

Private Sub DiffuseProc_Click()
' Diffuse
Dim rdx As Integer, rdy As Integer

BRelX = 5
BRelY = 5
   IMPARAM1.Show 1
If BRelX < 0 Then Exit Sub
Target.Cls
' get max. random displacement in x and y
For i = BRelY To YRes - BRelY
    For j = BRelX To XRes - BRelX
        rdx = Rnd * BRelX   ' random x displacement
        rdy = Rnd * BRelY   ' random y displacement
        dr = pic(j + rdx, i + rdy, 0)
        dg = pic(j + rdx, i + rdy, 1)
        db = pic(j + rdx, i + rdy, 2)
        Target.PSet (j, YRes - i - 1), RGB(dr, dg, db)
    Next
    Target.Refresh
Next

End Sub

Private Sub EmbossProc_Click()
' Emboss
Dim vpic(2) As Integer
BRelX = 1
BRelY = 1
IMPARAM1.Show 1
If BRelX < 0 Then Exit Sub
Target.Cls
For i = BRelY To YRes - BRelY
    For j = BRelX To XRes - BRelX
        For k = 0 To 2
            vpic(k) = pic(j, i, k) - pic(j - BRelX, i - BRelY, k) + 128
            If vpic(k) < 0 Then vpic(k) = 0
            If vpic(k) > 255 Then vpic(k) = 255
        Next
        Target.PSet (j, YRes - i - 1), RGB(vpic(0), vpic(1), vpic(2))
    Next
    Target.Refresh
Next

End Sub

Private Sub EngraveProc_Click()
' Engrave
BRelX = 1
BRelY = 1
IMPARAM1.Show 1
If BRelX < 0 Then Exit Sub
Target.Cls
For i = BRelY To YRes - BRelY
    For j = BRelX To XRes - BRelX
        For k = 0 To 2
            vpic(k) = pic(j, i, k) - pic(j + BRelX, i + BRelY, k) + 128
            If vpic(k) < 0 Then vpic(k) = 0
            If vpic(k) > 255 Then vpic(k) = 255
        Next
        Target.PSet (j, YRes - i - 1), RGB(vpic(0), vpic(1), vpic(2))
    Next
    Target.Refresh
Next

End Sub

Private Sub ExitProgram_Click()

    End

End Sub

Private Sub FileOpen_Click()

    ImageFind.Show

End Sub

Private Sub FileSaveAs_Click()
    
CommonDialog1.Filter = "Image Files|*.DIB"
CommonDialog1.Flags = 2
CommonDialog1.Action = 2
If CommonDialog1.filename = "" Then
    Exit Sub
Else
    SavePicture Target.IMAGE, CommonDialog1.filename
End If
     
End Sub

Private Sub Form_Load()

    Show
    DriveName = Left$(App.Path, 3)
    ChDrive DriveName
    ChDir App.Path

End Sub

Private Sub InvertProc_Click()
' Invert colors
Target.Cls

For i = 0 To YRes - 1
    For j = 0 To XRes - 1
        For k = 0 To 2
            vpic(k) = 255 - pic(j, i, k)
        Next
        Target.PSet (j, YRes - i - 1), RGB(vpic(0), vpic(1), vpic(2))
    Next
    Target.Refresh
Next

End Sub

Private Sub MosaicProc_Click()
' Mosaic
Dim mosaic As Integer, vpic As Integer
BRelX = 5
BRelY = 5
IMPARAM1.Show 1
If BRelX < 0 Then Exit Sub
Target.Cls
BlockSize = BRelX * BRelY
For i = 0 To YRes - BRelY Step BRelY
    For j = 0 To XRes - BRelX Step BRelX
        mr = 0: mg = 0: mb = 0
        For k1 = 0 To BRelY
            For k2 = 0 To BRelX
                mr = mr + pic(j + k1, i + k2, 0)    ' red tones
                mg = mg + pic(j + k1, i + k2, 1)    ' green tones
                mb = mb + pic(j + k1, i + k2, 2)    ' blue tones
            Next
        Next
        mr = mr / BlockSize    ' red average
        mg = mg / BlockSize    ' green average
        mb = mb / BlockSize    ' blue average
        For k1 = 0 To BRelY
            For k2 = 0 To BRelX
                Target.PSet (j + k2, YRes - i - 1 + k1), RGB(mr, mg, mb)
            Next
        Next
        mosaic = 0
    Next
    Target.Refresh
Next

End Sub

Private Sub NeonProc_Click()
' Neon effect (image gradient)
Target.Cls
For i = 0 To YRes - 1
    For j = 0 To XRes - 1
        For k = 0 To 2
            g1 = (pic(j, i, k) - pic(j + 1, i, k)) ^ 2
            g2 = (pic(j, i, k) - pic(j, i + 1, k)) ^ 2
            vpic(k) = 2 * (g1 + g2) ^ 0.5
            If vpic(k) > 255 Then vpic(k) = 255
        Next
        Target.PSet (j, YRes - i - 1), RGB(vpic(0), vpic(1), vpic(2))
    Next
    Target.Refresh
Next

End Sub

Private Sub SharpenProc_Click()
' Sharpen
Target.Cls
SharpenPercent = 0.25
IMPARAM2.Show 1
If SharpenPercent < 0 Then Exit Sub
' Get degree of sharpness
SharpenX = 1
SharpenY = 1

' for each pixel in the image
For i = SharpenY To YRes - SharpenY
    For j = SharpenX To XRes - SharpenX
        ' for each color component
        For k = 0 To 2
            vpic(k) = pic(j, i, k) + SharpenPercent * (pic(j, i, k) - pic(j - SharpenX, i - SharpenY, k)) 'Abs(pic(j, i, k) - pic(j - BRelX, i - BRelY, k))
            If vpic(k) < 0 Then vpic(k) = 0
            If vpic(k) > 255 Then vpic(k) = 255
        Next
        Target.PSet (j, YRes - i - 1), RGB(vpic(0), vpic(1), vpic(2))
    Next
Target.Refresh
Next

End Sub

Private Sub SmoothProc_Click()
' Smooth (LPF)
BlockSize = 3
IMPARAM3.Show 1         ' Prompt use to enter Blocksize
If BlockSize < 0 Then Exit Sub
Target.Cls
' for each pixel in the image
For i = Int(BlockSize / 2) To YRes - Int(BlockSize / 2)
     For j = Int(BlockSize / 2) To XRes - Int(BlockSize / 2)
        ' for each element in filter
        For k1 = -Int(BlockSize / 2) To Int(BlockSize / 2)
            For k2 = -Int(BlockSize / 2) To Int(BlockSize / 2)
                ' and for each color component
                For k = 0 To 2
                    vpic(k) = vpic(k) + pic(j + k1, i + k2, k)
                Next
            Next
        Next
        For k = 0 To 2
            vpic(k) = vpic(k) / BlockSize ^ 2
        Next
        Target.PSet (j, YRes - i - 1), RGB(vpic(0), vpic(1), vpic(2))
    Next
    Target.Refresh
Next

End Sub

